-- enhancedSound
--
-- Author Rival

enhancedSound = {};

function enhancedSound.prerequisitesPresent(specializations)
    return true;
end;

function enhancedSound:load(xmlFile)
	self.motorloadpitch = 0;
end;
function enhancedSound:delete()
end;
function enhancedSound:mouseEvent(posX, posY, isDown, isUp, button)
end;
function enhancedSound:keyEvent(unicode, sym, modifier, isDown)
end;

function enhancedSound:update(dt)
	if self:getIsActive() then
		local minRpm = self.motor.minRpm;
        local maxRpm = self.motor.maxRpm;
        local maxSpeed;
		if self.movingDirection >= 0 then
			maxSpeed = self.motor.maxForwardSpeed*0.001;
		else
			maxSpeed = self.motor.maxBackwardSpeed*0.001;
		end
		-- The actual rpm offset is 80% from the motor and 20% from the speed
		local targetRpmOffset = (self.motor.lastMotorRpm-minRpm)*0.8 + math.min(self.lastSpeed/maxSpeed, 1)*(maxRpm-minRpm)*0.2;
		local alpha = math.pow(0.01, dt*0.001);
		local roundPerMinute = targetRpmOffset + alpha*(self.lastRoundPerMinute-targetRpmOffset);
		local roundPerSecond = roundPerMinute / 60;     
		
		local motorSoundRunPitch = math.min(self.sampleMotorRun.pitchOffset + self.motorSoundRunPitchScale*math.abs(roundPerSecond), self.motorSoundRunPitchMax);
		if self.motorloadpitch > self.motor.motorLoad/2.68 then
			self.motorloadpitch = self.motorloadpitch-dt/1500;
		elseif self.motorloadpitch < self.motor.motorLoad/2.68 then
			self.motorloadpitch = self.motorloadpitch+dt/1500;
		end;
		motorSoundRunPitch = motorSoundRunPitch+self.motorloadpitch*0.1;
		
		SoundUtil.setSamplePitch(self.sampleMotorRun, motorSoundRunPitch);
	end;
end;

function enhancedSound:updateTick(dt)
end;
function enhancedSound:draw()
end;